> For the complete documentation index, see [llms.txt](https://docs.ionos.com/cloud/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.ionos.com/cloud/nodejs/cloud-api/models/kubernetesnodepoolpropertiesforput.md).

# KubernetesNodePoolPropertiesForPut

## Properties

| Name                  | Type                                                                                             | Description                                                                                                                                                                                                                                                                                                                                                        | Notes                               |
| --------------------- | ------------------------------------------------------------------------------------------------ | ------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------ | ----------------------------------- |
| **annotations**       | **{ \[key: string]: string; }**                                                                  | The annotations attached to the node pool.                                                                                                                                                                                                                                                                                                                         | \[optional] \[default to undefined] |
| **autoScaling**       | [**KubernetesAutoScaling**](/cloud/nodejs/cloud-api/models/kubernetesautoscaling.md)             |                                                                                                                                                                                                                                                                                                                                                                    | \[optional] \[default to undefined] |
| **k8sVersion**        | **string**                                                                                       | The Kubernetes version running in the node pool. Note that this imposes restrictions on which Kubernetes versions can run in the node pools of a cluster. Also, not all Kubernetes versions are suitable upgrade targets for all earlier versions.                                                                                                                 | \[optional] \[default to undefined] |
| **labels**            | **{ \[key: string]: string; }**                                                                  | The labels attached to the node pool.                                                                                                                                                                                                                                                                                                                              | \[optional] \[default to undefined] |
| **lans**              | [**Array\<KubernetesNodePoolLan>**](/cloud/nodejs/cloud-api/models/kubernetesnodepoollan.md)     | The array of existing private LANs to attach to worker nodes.                                                                                                                                                                                                                                                                                                      | \[optional] \[default to undefined] |
| **maintenanceWindow** | [**KubernetesMaintenanceWindow**](/cloud/nodejs/cloud-api/models/kubernetesmaintenancewindow.md) |                                                                                                                                                                                                                                                                                                                                                                    | \[optional] \[default to undefined] |
| **name**              | **string**                                                                                       | A Kubernetes node pool name. Valid Kubernetes node pool name must be 63 characters or less and must be empty or begin and end with an alphanumeric character (\[a-z0-9A-Z]) with dashes (-), underscores (\_), dots (.), and alphanumerics between.                                                                                                                | \[optional] \[default to undefined] |
| **nodeCount**         | **number**                                                                                       | The number of worker nodes of the node pool.                                                                                                                                                                                                                                                                                                                       | \[default to undefined]             |
| **publicIps**         | **Array\<string>**                                                                               | Optional array of reserved public IP addresses to be used by the nodes. The IPs must be from the exact location of the node pool's data center. If autoscaling is used, the array must contain one more IP than the maximum possible number of nodes (nodeCount+1 for a fixed number of nodes or maxNodeCount+1). The extra IP is used when the nodes are rebuilt. | \[optional] \[default to undefined] |


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.ionos.com/cloud/nodejs/cloud-api/models/kubernetesnodepoolpropertiesforput.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
